// var analyticsPlugin = require('analytics.js-plugin')
// var AnalyticsVimeo = analyticsPlugin()
var exportPlugin = require('../../lib/exportPlugin')
var AnalyticsVimeo = function () {}

// Install attaches the plugin to an analytics.js singleton for easier access
AnalyticsVimeo.prototype.install = function(analytics) {
  analytics.plugins = analytics.plugins || {}
  analytics.plugins.analyticsVimeo = this
}

AnalyticsVimeo.prototype.listen = function(player, metadata) {
  if (Array.isArray(player)) {
    player.forEach(function (obj) {
      this.listen(obj.player, obj.metadata)
    }, this)
  }

  player.on('play', (data) => this.trackPlay(data, metadata))
  player.on('pause', (data) => this.trackPause(data, metadata))
  player.on('ended', (data) => this.trackEnded(data, metadata))
}

AnalyticsVimeo.prototype.trackPlay = function (data, metadata) {
  window.analytics.track('Video Content Started', metadata)
}

// Having a name be explicitly defined is not necessary as we can use `this.name`
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/name
// Problem is this is not supported on IE. 
module.exports = exportPlugin(AnalyticsVimeo, 'AnalyticsVimeo')